/*
type ColumnItemConfig = {
  title: '', // string | () => {}
  key: '', // string
  groupKey?: '', // string
  render?: text => text, // () => {}
  sortable?: true, // boolean
  valueEnum?: [], // [] | {} | map
  fixed?: 'left', // 'left' | 'right'
  linkConfig?: {
    url: '', // string
    tabName: '', // string
    routerParams: ['key', 'value']
  },
  defaultChecked?: true, // boolean: true | false
  width?: 100, // number
  // hide: false // boolean | () => boolean
  hideInTable: boolean,
  hideInSearch: boolean,
  initialValue: any,
  dataType: string, // default: 'input', 'input' | 'select' | 'date' | 'dateRange'
}

interface ProTableProps {
  columns: ColumnItemConfig[],
  manualQuery?: boolean,// default: false 是否手动请求数据
  queryTable: () => {},
  summaryAPI: () => {}// 汇总数据的api，如果存在则需要处理汇总数据
}
*/
// import moment from 'moment'
// import { queryTMAccountList, queryTMAccountSummary } from '@/service/report'

export var defaultProps = {
  // loading: {// checkPermission: {
  //   type: Boolean,
  //   default: false
  // },
  // permissionConfig: {
  //   type: Object,
  //   default: () => ({
  //     props: [] // 列权限
  //   })
  // },
  rowKey: String | undefined,
  localStorageKey: String, // 自定义列存local storage的key
  columns: {
    type: Array,
    'default': function _default() {
      return [];
    }
  },
  queryPermissionFn: { // 权限数据的请求方法
    type: Function,
    'default': null
  },
  queryTableDataFn: { // 表格数据的请求方法
    type: Function,
    'default': null
    // default: async (params) => {
    //   try {
    //     const { startDate } = params
    //     if (startDate) {
    //       params.endDate = moment(startDate).add(1, 'days').format('YYYY-MM-DD')
    //     }
    //     const res = await queryTMAccountList(params)
    //     return Promise.resolve(res)
    //   } catch (error) {
    //     return Promise.reject(error)
    //   }
    // }
  },
  exportTableFn: {
    type: Function,
    'default': function _default() {}
  },
  openTabFn: {
    type: Function,
    'default': function _default() {}
  },
  summeryFn: { // 汇总数据的请求方法
    type: Function,
    'default': null
    // default: async () => {
    //   try {
    //     const res = await queryTMAccountSummary()
    //     Promise.resolve(res)
    //   } catch (error) {
    //     Promise.reject(error)
    //   }
    // }
  },
  columnsSettable: { // 是否支持自定义列设置
    type: Boolean,
    'default': true
  },
  pagination: {
    type: Object,
    'default': function _default() {
      return {
        total: 0,
        pageSize: 10,
        current: 1,
        showTotal: function showTotal(total) {
          return '共' + total + '条';
        },

        showQuickJumper: true,
        showSizeChanger: true,
        pageSizeOptions: ['10', '20', '30', '50']
      };
    }
  }
};